#pragma once

#include <jni.h>

namespace sf
{
namespace core
{
namespace android
{

/**
 *  C++ wrapper for Java AudioTrack class
 */
class CAudioTrack
{
public:
	CAudioTrack();
	CAudioTrack(const CAudioTrack &);
	~CAudioTrack();

	CAudioTrack & operator = (const CAudioTrack &);

	void Open(int _sample_rate, int _channels_count, JNIEnv* _env);
	void Close(JNIEnv* _env);
	void Play(JNIEnv* _env);
	void Pause(JNIEnv* _env);
	void Stop(JNIEnv* _env);
	void Write(jarray _buffer, int _size, JNIEnv* _env);
	void SetVolume(float _vol, JNIEnv* _env);

private:
	jobject m_Track;
};

}
}
}
