#pragma once

#include <sf/core/settings.h>
#include <sf/gui/widget.h>
#include <sf/graphics/surface.h>
#include <sf/graphics/texture.h>

namespace sf
{
namespace gui
{
class CButtonWidget;
class CImageWidget;
}
}

namespace game
{

class CBranch : public sf::gui::CWidget
{
public:
    CBranch();
    virtual ~CBranch();

    virtual void    OnAdd(sf::gui::CBaseWidget* _parent);

    bool SplashFinished();

private:
    struct SplashInfo
    {
        short							Time;
        short							ShowTime;
		sf::graphics::CImage			*m_Image;
    };

    typedef std::list<SplashInfo> SplashesT;

	void                LoadSplash(const char *_id);

    void    ShowSplash();

    void    DoUpdate();
    void    DoDraw(sf::graphics::CRenderer* _renderer) const;
	bool	OnMouseDown(const sf::misc::IntVector& _pos, MouseButtons _button, int _keyboard_state, bool _broadcast);
	
    SplashesT   m_Splashes;
    boost::intrusive_ptr<sf::gui::CImageWidget> m_CurrentSplash;
    float       m_CurrentSplashTime;
    bool        m_SplashEnded;

};
} // namespace game
