#include "DrawWindowWidget.h"

namespace game
{

CDrawWindowWidget::CDrawWindowWidget(sf::gui::CBaseWindow::WindowPtrT window) :
	sf::gui::CWidget()
	,m_Window(window)
{
	if	(m_Window)
	{
		SetOffset(window->GetOffset().X, window->GetOffset().Y);
		SetSize(window->GetSize().X, window->GetSize().Y);
		window->SetOffset(0.f, 0.f);
		sf::gui::CBaseWindow::WindowPtrT parent(m_Window->GetParentWindow());
		if	(parent)
		{
			parent->AddWidget(sf::gui::CBaseWidget::WidgetPtrT(this));	
		}
	}
}

CDrawWindowWidget::~CDrawWindowWidget()
{
}

void CDrawWindowWidget::DoDraw(sf::graphics::CRenderer *_renderer) const
{
	sf::gui::CWidget::DoDraw(_renderer);
	m_Window->Draw(_renderer);
}

} // namespace game