#include "FlurryAgent.h"
#include <sf/core/android/jni.h>

namespace game
{

static jclass g_FlurryAgentClass = 0;
static jmethodID g_MethodOnMoreGames = 0;
static jmethodID g_MethodOnNewsletter = 0;
static jmethodID g_MethodOnRateIt = 0;
static jmethodID g_MethodOnRemindMeLater = 0;
static jmethodID g_MethodOnNoThanks = 0;
static jmethodID g_MethodOnStartPurchase = 0;
static jmethodID g_MethodOnPurchaseCompleted = 0;
static jmethodID g_MethodOnPurchaseScreenClose = 0;

static  CFlurryAgent * g_instance;

CFlurryAgent & CFlurryAgent::Instance()
{
	if(!g_instance)
		g_instance = new CFlurryAgent();
	return *g_instance;
}

void CFlurryAgent::OnMoreGames()
{
	sf::core::g_JavaEnv->CallStaticVoidMethod(g_FlurryAgentClass, g_MethodOnMoreGames);
}

void CFlurryAgent::OnNewsletter()
{
	sf::core::g_JavaEnv->CallStaticVoidMethod(g_FlurryAgentClass, g_MethodOnNewsletter);
}

void CFlurryAgent::OnRateIt()
{
	sf::core::g_JavaEnv->CallStaticVoidMethod(g_FlurryAgentClass, g_MethodOnRateIt);
}

void CFlurryAgent::OnRemindMeLater()
{
	sf::core::g_JavaEnv->CallStaticVoidMethod(g_FlurryAgentClass, g_MethodOnRemindMeLater);
}

void CFlurryAgent::OnNoThanks()
{
	sf::core::g_JavaEnv->CallStaticVoidMethod(g_FlurryAgentClass, g_MethodOnNoThanks);
}

void CFlurryAgent::OnStartPurchase(const char * _purchaseId)
{
    jstring link = sf::core::g_JavaEnv->NewStringUTF(_purchaseId);
    sf::core::g_JavaEnv->CallStaticVoidMethod(g_FlurryAgentClass, g_MethodOnStartPurchase, link);
    sf::core::g_JavaEnv->DeleteLocalRef(link);
}

void CFlurryAgent::OnPurchaseCompleted(const char * _purchaseId)
{
    jstring link = sf::core::g_JavaEnv->NewStringUTF(_purchaseId);
    sf::core::g_JavaEnv->CallStaticVoidMethod(g_FlurryAgentClass, g_MethodOnPurchaseCompleted, link);
    sf::core::g_JavaEnv->DeleteLocalRef(link);
}

void CFlurryAgent::OnPurchaseScreenClose()
{
	sf::core::g_JavaEnv->CallStaticVoidMethod(g_FlurryAgentClass, g_MethodOnPurchaseScreenClose);
}

CFlurryAgent::CFlurryAgent()
{
    g_FlurryAgentClass = sf::core::JNIGetClass("com/stargaze/flurry/FlurryAgent");

    g_MethodOnMoreGames = sf::core::JNIGetStaticMethod(g_FlurryAgentClass,
        "onMoreGames", "()V");
    g_MethodOnNewsletter = sf::core::JNIGetStaticMethod(g_FlurryAgentClass,
        "onNewsletter", "()V");
    g_MethodOnRateIt = sf::core::JNIGetStaticMethod(g_FlurryAgentClass,
        "onRateIt", "()V");
    g_MethodOnRemindMeLater = sf::core::JNIGetStaticMethod(g_FlurryAgentClass,
        "onRemindMeLater", "()V");
    g_MethodOnNoThanks = sf::core::JNIGetStaticMethod(g_FlurryAgentClass,
        "onNoThanks", "()V");
    g_MethodOnStartPurchase = sf::core::JNIGetStaticMethod(g_FlurryAgentClass,
        "onStartPurchase", "(Ljava/lang/String;)V");
    g_MethodOnPurchaseCompleted = sf::core::JNIGetStaticMethod(g_FlurryAgentClass,
        "onPurchaseCompleted", "(Ljava/lang/String;)V");
    g_MethodOnPurchaseScreenClose = sf::core::JNIGetStaticMethod(g_FlurryAgentClass,
        "onPurchaseScreenClose", "()V");
}

}
