#pragma once

namespace game
{

/**
 * Proxy class into Java Flurry agent
 */
class CFlurryAgent
{
public:

	/**
	 * Return a single instance of this class
	 */
	static CFlurryAgent & Instance();

	/**
	 * Button "More Games" clicked
	 */
	void OnMoreGames();

	/**
	 * "Newsletter" button clicked
	 */
	void OnNewsletter();

	/**
	 * "Rate it now!" button clicked
	 */
	void OnRateIt();

	/**
	 * "Remind me later" button clicked
	 */
	void OnRemindMeLater();

	/**
	 * "No, Thanks" button clicked
	 */
	void OnNoThanks();

	/**
	 * User click button "Purchase" and purchase process started
	 * @param _purchaseId identifier of purchase
	 */
	void OnStartPurchase(const char * _purchaseId);

	/**
	 * Purchase process is successfull and game resources unlocked
	 * @param _purchaseId identifier of purchase
	 */
	void OnPurchaseCompleted(const char * _purchaseId);

	/**
	 * Nagscreen closed
	 */
	void OnPurchaseScreenClose();

private:
	CFlurryAgent();
};

}
