#pragma once

#include "jni.h"
#include <sf/misc/String.h>

namespace sf
{
namespace core
{
namespace android
{

class CJavaAudioPlayer
{
public:
	CJavaAudioPlayer();
	CJavaAudioPlayer(const CJavaAudioPlayer & rhs);
	CJavaAudioPlayer & operator = (const CJavaAudioPlayer & rhs);

	~CJavaAudioPlayer();
	bool Open(const char * _file, int _offset, int _length, bool _loop);
	void Close();

	void Start();
	void Stop();
	void Pause();
	bool IsPlaying() const;
	int GetDuration() const;
	void SetVolume(float _volume);

private:
	static void Init();
	jobject CreateMusic(const StringA120& _path);
	jobject CreateMusicfromGamePack(size_t _offset, size_t _length);

private:
	jobject m_Player;

    static jclass m_JavaMediaManager;
    static jmethodID m_CreateMusic;
	static jmethodID m_CreateMusicfromGamePack;
    static jmethodID m_MPStart;
    static jmethodID m_MPPause;
    static jmethodID m_MPStop;
    static jmethodID m_MPIsPlaying;
    static jmethodID m_MPSetVolume;
    static jmethodID m_MPGetDuration;
    static jmethodID m_MPSetLooping;
    static jmethodID m_MPRelease;
    static jmethodID m_MPReset;
};

}
}
}