#pragma once

#include <sf/sf.h>

#ifdef __SF_ANDROID
#include <sf/core/android/AndroidApplication.h>
#endif

#include <sf/misc/vector.h>

namespace sf
{
namespace lua { class CLua; }
}

namespace game
{

class CTouchesHandlerObserver
{
public:
	virtual void PinchZoom(float _coef, const sf::misc::FloatVector& _pos1, const sf::misc::FloatVector& _pos2) = 0;
};

class CTouchesHandler 
{
public:
    CTouchesHandler();
	~CTouchesHandler();

    // subscribes to and unsubscribes from iPhone StandaloneApplication's touch events.
    void Subscribe(CTouchesHandlerObserver& _observer);
    void Unsubscribe();
        
    int TouchBegin(int _touch, float _x, float _y);
    int TouchMove(int _touch, float _x, float _y);
    int TouchEnd(int _touch, float _x, float _y);
       
private:
    enum { MaxTouches = 2 };

#ifdef __SF_ANDROID
    sf::core::AndroidTouchSubscribeContext m_Context;
#endif
    
    sf::misc::IntVector m_TouchesPos[MaxTouches]; // contains touch positions by touch uids
    int m_ActiveTouches[MaxTouches]; // contains touches' uids in touch order
    int m_TouchesCount;
    unsigned m_ActiveTouchesMask;
    float m_PrevDistance;
    CTouchesHandlerObserver * m_observer;
    
    sf::lua::CLua* m_Lua;
};

} //s10

