#include <sf/sf.h>
#include <sf/lua/lua.h>
#include <sf/lua/LuaBindHelpers.h>
#include <sf/diag/log.h>
#include <sf/diag/message.h>

namespace game
{
namespace lua
{

static void LogA(const char* _module, sf::diag::LogLevel _level, const char* _message)
{
	sf::diag::g_Log::Instance().LogA(_module, _level, _message);
}

static void LogW(const char* _module, sf::diag::LogLevel _level, const wchar_t* _message)
{
	sf::diag::g_Log::Instance().LogW(_module, _level, _message);
}

void BindDiag(sf::lua::CLua& _lua)
{
	using namespace mluabind;
	using namespace sf;

	_lua.StartBinding();

	_lua.Insert
	(
		Declare("sf")
			+ (Declare("diag")
                + Enum("LogTrace", diag::LogTrace)
                + Enum("LogInfo", diag::LogInfo)
                + Enum("LogWarning", diag::LogWarning)
                + Enum("LogError", diag::LogError)

//                + Function("LogW", &LogW)
                + Function("LogA", &LogA)

                + (Declare("message")
//                    + Function("Supress", &diag::message::Supress)
//                    + Function("ShowW", static_cast<void (*)(const wchar_t*)>(&diag::message::ShowW))
//                    + Function("ShowW", static_cast<void (*)(const wchar_t*, const wchar_t*)>(&diag::message::ShowW))
                    + Function("ShowA", static_cast<void (*)(const char*)>(&diag::message::ShowA))
                    + Function("ShowA", static_cast<void (*)(const char*, const char*)>(&diag::message::ShowA))
                )
			)
	);

	_lua.FinishBinding();
}

} //lua
} //game