#include <sf/sf.h>

#include <sf/lua/lua.h>
#include <sf/lua/LuaBindHelpers.h>
#include <sf/lua/LuaBindings.h>

namespace game
{
namespace lua
{

void BindLua(sf::lua::CLua& _lua)
{
	using namespace mluabind;
	using namespace sf;
	using namespace sf::lua;
	
	_lua.StartBinding();

	_lua.Insert
	(
		Declare("sf")
			+ (Declare("lua")
                + LUA_FUNCTION(BindSF)
				+ LUA_CLASS(CLua)
					.Constructor<const std::string&, bool>()
					.LUA_CLASS_METHOD(CLua, LoadScript)
					.LUA_CLASS_METHOD(CLua, LoadLuaScripts)					
//					.LUA_CLASS_METHOD_OVERLOAD(CLua, Run, bool (CLua::*)(const SF_WSTRING&))
					.LUA_CLASS_METHOD_OVERLOAD(CLua, Run, bool (CLua::*)(const std::string&))
//					.LUA_CLASS_METHOD(CLua, CheckFileChanges)
					.LUA_CLASS_METHOD(CLua, GetId)
				+ (Declare("CLua")
					+ Function("GetLua", &CLua::GetLua)
					)
			)
	);

	_lua.FinishBinding();
}

} //lua
} //game