#pragma once

#include <windows.h>

namespace game
{

class CResourcesDownloader
{
public:
    static CResourcesDownloader& Instance();
    
    ~CResourcesDownloader();

    //      
    //  false,     
	bool DownloadFile(const char* _source_link);
    
	bool IsDownloading();
	bool IsError() { return false; }
    
    //   
    //    DownloadFile    ,  
    //   ,    
    void StopDownload();
    
    //     
	void ResetDownload(const char* _source_link);
    
    //   
    int GetContentLength();

    //  
	int GetDownloadedLength();

	int GetResourcesSize(const char * _link) {return -1;}
private:
	static DWORD WINAPI DownloadThread(void *arg);
	void Download();

private:
    // singleton
    CResourcesDownloader();
	HANDLE m_thread;
	int m_length;
	int m_downloaded;
	bool m_downloading;
	CRITICAL_SECTION m_cs;
};

} // game